import java.util.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import sun.misc.*;


public class Main{

  public static final String CRYPTO_KEY_STR = "Java profiling with SystemTap";


  private static byte[] generateCryptoKey(String keyStr, int bits){
    byte[] key = new byte[bits];
    byte[] keyStrBytes = keyStr.getBytes();
    int Cnt;

    for(Cnt = 0; (Cnt < bits) && (Cnt < keyStr.length()); Cnt++)
      key[Cnt] = keyStrBytes[Cnt];

    for(; Cnt < bits; Cnt++)
      key[Cnt] = 0;

    return key;
  }

  private static Cipher createCipher(byte[] key, String algorithm) throws Exception{
    SecretKeySpec spec = new SecretKeySpec(key, algorithm);

    Cipher cipher = Cipher.getInstance(algorithm);
    cipher.init(Cipher.ENCRYPT_MODE, spec);

    return cipher;
  }

  private static void processCipher(Cipher cipher, String value) throws Exception{
    System.out.printf("  %8s: %s\n", cipher.getAlgorithm(),
                         (new BASE64Encoder()).encode(cipher.doFinal(value.getBytes())));
  }

  public static void main(String[] args) throws Exception{
    byte[] cryptoKey = generateCryptoKey(CRYPTO_KEY_STR, 24);
    Cipher AES = createCipher(cryptoKey, "AES");
    Cipher Blowfish = createCipher(cryptoKey, "Blowfish");
    Cipher DESede = createCipher(cryptoKey, "DESede");

    String sampleString;

    while(true){
      sampleString = (new Date(System.currentTimeMillis())).toString();
      System.out.println(sampleString);

      processCipher(AES, sampleString);
      processCipher(Blowfish, sampleString);
      processCipher(DESede, sampleString);

      System.out.println();
      Thread.sleep(1000);
    }

  }

}


